﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace EventTest
{
    class EventTest
    {
        public EventTest()
        {
            MyButton button1 = new MyButton();

            Console.WriteLine("클릭 이벤트 추가 후 버튼 클릭");
            button1.MyButtonEvent += new MyButtonEventHandler(this.button1_Click);
            button1.OnMyButtonEvent();

            Console.WriteLine("변경 이벤트 추가 후 버튼 클릭");
            button1.MyButtonEvent += new MyButtonEventHandler(this.button1_Change);
            button1.OnMyButtonEvent();

            Console.WriteLine("클릭 이벤트 제거 후 버튼 클릭");
            button1.MyButtonEvent -= new MyButtonEventHandler(this.button1_Click);
            button1.OnMyButtonEvent();

            Console.WriteLine("새로운 클릭 레이블 이벤트 추가 후 버튼 클릭");
            button1.Label = "테스트";
            button1.ClickEvent += new ClickEventHandler(this.button1_Label);
            button1.OnClickEvent();

            Console.WriteLine("새로운 클릭 레이블 이벤트 추가 후 버튼 클릭2");
            button1.Label = "테스트2";
            button1.ClickEvent += new ClickEventHandler(this.button1_Label2);
            button1.OnClickEvent();
        }

        void button1_Click()
        {
            Console.WriteLine("->버튼에서 클릭 이벤트 발생");
        }

        void button1_Change()
        {
            Console.WriteLine("->버튼에서 변경 이벤트 발생");
        }

        void button1_Label(string label)
        {
            Console.WriteLine("->버튼에서 레이블 이벤트 발생: " + label);
        }

        void button1_Label2(string label)
        {
            Console.WriteLine("->버튼에서 레이블 이벤트 발생2: " + label);
        }

        static void Main(string[] args)
        {
            EventTest e = new EventTest();
        }
    }
}
